;My solution to a common problem, viz. how to explode blocks with
;attributes, and retain the attribute value as text.  Text is
;placed on the block layer.
;
(defun C:A2T ; Attribute 2 Text by Donald Pirl CIS: 71174,1113
  (/ bep ben ded bet bln aen aed atg afg afl avj aet len led let)
  (command "._undo" "group")
  (while (/= bet "INSERT")
    (setq
      bep (entsel "\nSelect block to explode: ")
      ben (car bep)
      bed (entget ben)
      bet (cdr (assoc '0 bed))
      bln (cdr (assoc '8 bed))
    )
  )
  (setq 
    aen ben
    len (entlast)
    ss (ssadd)
  )
  (while (/= aet "SEQEND")
    (setq
      aen (entnext aen)
      aed (entget aen)
      aet (cdr (assoc '0 aed))
      atg (assoc '2 aed)
      afg (assoc '70 aed)
      avj (assoc '74 aed)
      afl (assoc '73 aed)
      tvj (cons '73 (cdr avj))
    )
    (cond 
      ( (= aet "ATTRIB")
        (entdel aen)
        (setq 
          aed (subst (cons '0 "TEXT") (cons '0 "ATTRIB") aed)
          aed (rem-memb atg aed)
          aed (rem-memb afg aed)
          aed (rem-memb afl aed)
          aed (subst tvj avj aed)
        )
        (entmake aed) 
      )
    )
  )
  (command "._explode" ben "")
  (while (entnext len)
    (setq
      len (entnext len)
      led (entget len)
      let (cdr (assoc '0 led))
      lel (cdr (assoc '8 led))
    )
    (cond
      ( (= "ATTDEF" let)
        (entdel len)
      )
      ( (= "TEXT" let)
        (redraw len 1)
      )
    )
    (cond 
      ( (and (/= bln lel) (/= "TEXT" let))
        (setq
          led (subst (cons '8 bln) (cons '8 lel) led)
        )
        (entmod led)
      )
    )
  )
  (command "._undo" "end")
  (princ)
)
